using System;
using System.Collections.Generic;
using System.Text;
using System.IO.Ports;

namespace LocalTimeReader
{
    public class ConnectedSerialPort : SerialPort
    {
        protected virtual void ProcessDataReceived(object sender, EventArgs e)
        {
        }

        protected virtual void ConnectedSerialPort_PinChanged(object sender, SerialPinChangedEventArgs e)
        {
        }

        public virtual bool OpenPort(string port)
        {
            if (this.IsOpen)
                return true;

            this.PortName = port;

            this.BaudRate = 9600;
            this.Parity = Parity.None;
            this.DataBits = 8;
            this.StopBits = StopBits.One;
            this.Handshake = Handshake.RequestToSend;

            this.DataReceived += new SerialDataReceivedEventHandler(ProcessDataReceived);
            this.PinChanged += new SerialPinChangedEventHandler(ConnectedSerialPort_PinChanged);
            this.ErrorReceived += new SerialErrorReceivedEventHandler(ConnectedSerialPort_ErrorReceived);

            this.ReadTimeout = 500;
            this.WriteTimeout = 500;

            try
            {
                this.Open();
                // Get rid of crap build up particularly if devices
                // are switched on first
                this.DiscardInBuffer();
            }
            catch (Exception)
            {
                return false;
            }

            return true;

        }

        void ConnectedSerialPort_ErrorReceived(object sender, SerialErrorReceivedEventArgs e)
        {
//            MessageBox.Show("Received Data Error");
        }

    }
}
